<?php

declare(strict_types=1);

namespace Drupal\commerce_gc_client;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Interface for commerce_gc_client.recurrence_rules plugins.
 */
interface RecurrenceRulesInterface extends PluginInspectionInterface, ContainerFactoryPluginInterface {

  /**
   * Returns the translated plugin label.
   */
  public function label(): string;

  /**
   * Builds the associated form.
   *
   * @param $entity \Drupal\Core\Entity\EntityInterface.
   *   The entity this plugin is associated with.
   *
   * @return array().
   *   Render array of form that implements \Drupal\commerce_gc_client\Form\RecurrenceRulesFormInterface
   */
  public function buildForm($entity): array;

}
