<?php

declare(strict_types=1);

namespace Drupal\commerce_gc_client;

use Drupal\commerce_gc_client\Attribute\RecurrenceRules;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * Recurrence Rules plugin manager.
 */
final class RecurrenceRulesPluginManager extends DefaultPluginManager {

  /**
   * Constructs the object.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/CommerceGcClient/RecurrenceRules', $namespaces, $module_handler, RecurrenceRulesInterface::class, RecurrenceRules::class);
    $this->alterInfo('commerce_gc_client.recuurence_rules_info');
    $this->setCacheBackend($cache_backend, 'commerce_gc_client.recurrence_rules_plugins');
  }

}
